config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  resources :mail_bodies
  resources :public_templates

  resources :projects do
    resources :transactions
    resources :templates
    resources :sending_emails
    resources :sending_providers_projects
  end

  root to: 'application#home'
  devise_for :users, :controllers => {:registrations => "registrations"}
  resources :users

  # pages
  get 'home', to: 'application#home'
  get '/dev_mailbox', to: 'dev_mailbox#index'
  get '/projects/:project_id/confirm_sending_emails', to: 'sending_emails#confirm_email'
  get '/projects/:project_id/sending_emails/:id/resend_confirmation', to: 'sending_emails#resend_confirmation'
  get '/projects/:project_id/transactions/:id/design', to: 'transactions#design'
  get '/projects/:id/api_security', to: 'projects#api_security'
  get '/projects/:project_id/create_from_provider/:sending_provider_id', to: 'sending_providers_projects#create_from_provider'

  # vue widget Api
  scope '/projects/:project_id/widjet/v1' do
    # designer endpoint
    scope '/designer' do
      post '/preview', to: 'api/widjet/designer#preview'
      post '/:designable_type/:id/upload_picture_asset', to: 'api/widjet/designer#create_local_picture_asset'
      post '/upload_picture_asset', to: 'api/widjet/designer#create_global_picture_asset'
      patch '/:designable_type/:id', to: 'api/widjet/designer#update_designable'
      delete '/delete_asset/:sendable_asset_id', to: 'api/widjet/designer#destroy_asset'
    end

    # Api security endpoint
    scope '/api_security' do
      post '/create_key/:env', to: 'api/widjet/api_security#generate_key'
      patch '/change_locks/:id', to: 'api/widjet/api_security#change_locks'
    end
  end

  # client Api endpoints
  scope '/v1', defaults: {format: :json} do
    post '/transmit/:code_name', to: 'api/v1/transmit_api#transmit_transaction'
  end


end

app/models/public_template.rb
class PublicTemplate < ApplicationRecord
  belongs_to :user

  include DesignableWrapper
end

app/controllers/public_templates_controller.rb
class PublicTemplatesController < ApplicationController
  before_action :set_public_template, only: [:show, :edit, :update, :destroy]

  # GET /public_templates
  # GET /public_templates.json
  def index
    @public_templates = PublicTemplate.all
  end

  # GET /public_templates/1
  # GET /public_templates/1.json
  def show
  end

  # GET /public_templates/new
  def new
    @public_template = PublicTemplate.new
  end

  # GET /public_templates/1/edit
  def edit
  end

  # POST /public_templates
  # POST /public_templates.json
  def create
    @public_template = PublicTemplate.new(public_template_params)

    respond_to do |format|
      if @public_template.save
        format.html { redirect_to @public_template, notice: 'Public template was successfully created.' }
        format.json { render :show, status: :created, location: @public_template }
      else
        format.html { render :new }
        format.json { render json: @public_template.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /public_templates/1
  # PATCH/PUT /public_templates/1.json
  def update
    respond_to do |format|
      if @public_template.update(public_template_params)
        format.html { redirect_to @public_template, notice: 'Public template was successfully updated.' }
        format.json { render :show, status: :ok, location: @public_template }
      else
        format.html { render :edit }
        format.json { render json: @public_template.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /public_templates/1
  # DELETE /public_templates/1.json
  def destroy
    @public_template.destroy
    respond_to do |format|
      format.html { redirect_to public_templates_url, notice: 'Public template was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_public_template
      @public_template = PublicTemplate.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def public_template_params
      params.require(:public_template).permit(:content_img, :styling_img)
    end
end

app/helpers/public_templates_helper.rb
module PublicTemplatesHelper
end

app/views/public_templates/_form.html.haml
= form_for @public_template do |f|
  - if @public_template.errors.any?
    #error_explanation
      %h2= "#{pluralize(@public_template.errors.count, "error")} prohibited this public_template from being saved:"
      %ul
        - @public_template.errors.full_messages.each do |message|
          %li= message

  .field
    = f.label :content_img
    = f.text_area :content_img
  .field
    = f.label :styling_img
    = f.text_area :styling_img
  .actions
    = f.submit 'Save'

app/views/public_templates/edit.html.haml
%h1 Editing public_template

= render 'form'

= link_to 'Show', @public_template
\|
= link_to 'Back', public_templates_path

app/views/public_templates/index.html.haml
%h1 Listing public_templates

%table
  %thead
    %tr
      %th Content img
      %th Styling img
      %th
      %th
      %th

  %tbody
    - @public_templates.each do |public_template|
      %tr
        %td= public_template.content_img
        %td= public_template.styling_img
        %td= link_to 'Show', public_template
        %td= link_to 'Edit', edit_public_template_path(public_template)
        %td= link_to 'Destroy', public_template, method: :delete, data: { confirm: 'Are you sure?' }

%br

= link_to 'New Public template', new_public_template_path

app/views/public_templates/new.html.haml
%h1 New public_template

= render 'form'

= link_to 'Back', public_templates_path

app/views/public_templates/show.html.haml
%p#notice= notice

%p
  %b Content img:
  = @public_template.content_img
%p
  %b Styling img:
  = @public_template.styling_img

= link_to 'Edit', edit_public_template_path(@public_template)
\|
= link_to 'Back', public_templates_path